-------------------------------------------------------------------------------
--! @file       Delta.vhd
--! @author     Farnoud Farahmand
--! @brief      Delta unit for AES_COPA
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Delta is
     port(
        input                    : in   std_logic_vector(127 downto 0);
		  init_delta,rst,clk,en    : in   std_logic;
        output                   : out  std_logic_vector(127 downto 0)
	  );

end Delta;

architecture Delta_arc of Delta is

   signal mux_out             : std_logic_vector(127 downto 0);
	signal reg_out             : std_logic_vector(127 downto 0);
   signal x2                  : std_logic_vector(127 downto 0);
begin

    mux_out <= input when init_delta='1' else x2;
	 
    reg128: entity work.Register_s(reg_arc) 
    port map (
             d        => mux_out,
             reset    => rst,
				 clock    => clk,
				 enable   => en,
				 q        => reg_out
				 );
	 multi2: entity work.Multi_2(Multi_2_arc) 
    port map (
             input     => reg_out,
             output    => x2);
				 
     	output <= reg_out;

end Delta_arc;

