-------------------------------------------------------------------------------
--! @file       Multi_2.vhd
--! @author     Farnoud Farahmand
--! @brief      Multiplication by 2 over galois field
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Multi_2 is
    port(
        input             : in  std_logic_vector(127 downto 0);
        output            : out  std_logic_vector(127 downto 0)
	  );

end Multi_2;

architecture Multi_2_arc of Multi_2 is

      signal tmp   : std_logic_vector (127 downto 0); 

begin
   
	  tmp     <= (7|2|1 => input(127), others => '0');
	  output  <= ((input(126 downto 0) & input(127)) xor tmp);

end Multi_2_arc;

