-------------------------------------------------------------------------------
--! @file       Multi_3.vhd
--! @author     Farnoud Farahmand
--! @brief      Multiplication by 3 over galois field
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Multi_3 is
    port(
        input             : in  std_logic_vector(127 downto 0);
        output            : out  std_logic_vector(127 downto 0)
	  );
	  
end Multi_3;

architecture Multi_3_arc of Multi_3 is

    signal x2             : std_logic_vector(127 downto 0);

begin
  
    multi2: entity work.Multi_2(Multi_2_arc) 
    port map (
        input         => input,
        output        => x2);
		  
		  output <= input xor x2;

end Multi_3_arc;

