-------------------------------------------------------------------------------
--! @file       Multi_7.vhd
--! @author     Farnoud Farahmand
--! @brief      Multiplication by 7 over galois field
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;



entity Multi_7 is
port(
        input             : in  std_logic_vector(127 downto 0);
        output            : out  std_logic_vector(127 downto 0)
	  );
	  
end Multi_7;

architecture Multi_7_arc of Multi_7 is

    signal x2             : std_logic_vector(127 downto 0);
	 signal x3             : std_logic_vector(127 downto 0);

begin
  
    multi2: entity work.Multi_2(Multi_2_arc) 
    port map (
        input         => input,
        output        => x2);
		  
	 multi3: entity work.Multi_3(Multi_3_arc) 
    port map (
        input         => x2,
        output        => x3);
		  
		  output <= input xor x3;



end Multi_7_arc;

