-------------------------------------------------------------------------------
--! @file       bit_expand.vhd
--! @author     Farnoud Farahmand
--! @brief      bdi_pad_loc expansion from 16 bits to 128 bits representation
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity bit_expand is
     port(
	      input           : in   std_logic_vector(15 downto 0);
          output          : out  std_logic_vector(127 downto 0)
	        );

end bit_expand;

architecture structure of bit_expand is

     signal init  : std_logic_vector(31 downto 0);
     type sel_array is array (0 to 15) of std_logic_vector(1 downto 0);
     signal sel : sel_array;
begin

    G1: for i in 0 to 15 generate
		G1: for j in 0 to 7 generate        
			output ((8*i)+j) <= input(i);
		end generate;
	end generate;	
						 
end structure;

