-------------------------------------------------------------------------------
--! @file       fixed_right_shift.vhd
--! @author     Farnoud Farahmand
--! @brief      Right shift by fix value
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity fixed_right_shift is

			GENERIC ( L    : INTEGER := 1;
			          size : INTEGER := 128
			         );
			PORT ( a : IN  STD_LOGIC_VECTOR(size-1 DOWNTO 0);
			       y : OUT STD_LOGIC_VECTOR(size-1 DOWNTO 0) 
					) ;
			 
end fixed_right_shift;

architecture dataflow of fixed_right_shift is

 signal zero  : STD_LOGIC_VECTOR(L-1 DOWNTO 0):= (others => '0');

begin
			
     y <= zero & a(size-1 downto L);

end dataflow;

